<?php

/**
 * Plugin : AP_Gestion_Utilisateurs - basé sur AP_User_Management
 * Version : 1.3 - Fr
 * Traduction : SamRay1024
 * http://jebulle.net
 * webmaster@jebulle.net
 */

/***********************************************************************

  Copyright (C) 2005  Connor Dunn (Connorhd@mypunbb.com)

  This software is free software; you can redistribute it and/or modify it
  under the terms of the GNU General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.

  This software is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
  MA  02111-1307  USA

************************************************************************/
// Make sure no one attempts to run this script "directly"
if (!defined('PUN'))
    exit;

// Tell admin_loader.php that this is indeed a plugin and that it is loaded
define('PUN_PLUGIN_LOADED', 1);
define('PLUGIN_VERSION',1.3);

if (isset($_POST['prune']))
{
	// Make sure something something was entered
	if ((trim($_POST['days']) == '') || trim($_POST['posts']) == '')
		message('Vous devez remplir tous les champs !');
	if ($_POST['admods_delete']) {
		$admod_delete = 'group_id > 0';
	}
	else {
		$admod_delete = 'group_id > 3';
	}

	if ($_POST['verified'] == 1)
		$verified = '';
	elseif ($_POST['verified'] == 0)
		$verified = 'AND (group_id < 32000)';
	else
		$verified = 'AND (group_id = 32000)';

	$prune = ($_POST['prune_by'] == 1) ? 'registered' : 'last_visit';

	$user_time = time() - ($_POST['days'] * 86400);
	$result = $db->query('DELETE FROM '.$db->prefix.'users WHERE (num_posts < '.intval($_POST['posts']).') AND ('.$prune.' < '.intval($user_time).') AND (id > 2) AND ('.$admod_delete.')'.$verified, true) or error('Impossible de supprimer les utilisateurs', __FILE__, __LINE__, $db->error());
	$users_pruned = $db->affected_rows();
	message('D&eacute;lestage effectu&eacute;. Utilisateurs supprim&eacutes;s '.$users_pruned.'.');
}
elseif (isset($_POST['add_user']))
{
	require PUN_ROOT.'lang/'.$pun_user['language'].'/prof_reg.php';
	require PUN_ROOT.'lang/'.$pun_user['language'].'/register.php';
	$username = pun_trim($_POST['username']);
	$email1 = strtolower(trim($_POST['email']));
	$email2 = strtolower(trim($_POST['email']));

	if ($_POST['random_pass'] == '1')
	{
		$password1 = random_pass(8);
		$password2 = $password1;
	}
	else
	{
		$password1 = trim($_POST['password']);
		$password2 = trim($_POST['password']);
	}

	// Convert multiple whitespace characters into one (to prevent people from registering with indistinguishable usernames)
	$username = preg_replace('#\s+#s', ' ', $username);

	// Validate username and passwords
	if (strlen($username) < 2)
		message($lang_prof_reg['Username too short']);
	else if (pun_strlen($username) > 25)	// This usually doesn't happen since the form element only accepts 25 characters
	    message($lang_common['Bad request']);
	else if (strlen($password1) < 4)
		message($lang_prof_reg['Pass too short']);
	else if ($password1 != $password2)
		message($lang_prof_reg['Pass not match']);
	else if (!strcasecmp($username, 'Guest') || !strcasecmp($username, $lang_common['Guest']))
		message($lang_prof_reg['Username guest']);
	else if (preg_match('/[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}/', $username))
		message($lang_prof_reg['Username IP']);
	else if ((strpos($username, '[') !== false || strpos($username, ']') !== false) && strpos($username, '\'') !== false && strpos($username, '"') !== false)
		message($lang_prof_reg['Username reserved chars']);
	else if (preg_match('#\[b\]|\[/b\]|\[u\]|\[/u\]|\[i\]|\[/i\]|\[color|\[/color\]|\[quote\]|\[quote=|\[/quote\]|\[code\]|\[/code\]|\[img\]|\[/img\]|\[url|\[/url\]|\[email|\[/email\]#i', $username))
		message($lang_prof_reg['Username BBCode']);

	// Check username for any censored words
	if ($pun_config['o_censoring'] == '1')
	{
		// If the censored username differs from the username
		if (censor_words($username) != $username)
			message($lang_register['Username censor']);
	}

	// Check that the username (or a too similar username) is not already registered
	$result = $db->query('SELECT username FROM '.$db->prefix.'users WHERE username=\''.$db->escape($username).'\' OR username=\''.$db->escape(preg_replace('/[^\w]/', '', $username)).'\'') or error('Impossible de r&eacute;cup&eacute;rer les infos de l\'utilisateur', __FILE__, __LINE__, $db->error());

	if ($db->num_rows($result))
	{
		$busy = $db->result($result);
		message($lang_register['Username dupe 1'].' '.pun_htmlspecialchars($busy).'. '.$lang_register['Username dupe 2']);
	}


	// Validate e-mail
	require PUN_ROOT.'include/email.php';

	if (!is_valid_email($email1))
		message($lang_common['Invalid e-mail']);

	// Check if someone else already has registered with that e-mail address
	$dupe_list = array();

	$result = $db->query('SELECT username FROM '.$db->prefix.'users WHERE email=\''.$email1.'\'') or error('Impossible de r&eacute;cup&eacute;rer les infos de l\'utilisateur', __FILE__, __LINE__, $db->error());
	if ($db->num_rows($result))
	{
		while ($cur_dupe = $db->fetch_assoc($result))
			$dupe_list[] = $cur_dupe['username'];
	}

	$timezone = '0';
	$language = isset($_POST['language']) ? $_POST['language'] : $pun_config['o_default_lang'];
	$save_pass = (!isset($_POST['save_pass']) || $_POST['save_pass'] != '1') ? '0' : '1';

	$email_setting = intval(1);

	// Insert the new user into the database. We do this now to get the last inserted id for later use.
	$now = time();

	$intial_group_id = ($_POST['random_pass'] == '0') ? $pun_config['o_default_user_group'] : PUN_UNVERIFIED;
	$password_hash = pun_hash($password1);

	// Add the user
	$db->query('INSERT INTO '.$db->prefix.'users (username, group_id, password, email, email_setting, save_pass, timezone, language, style, registered, registration_ip, last_visit) VALUES(\''.$db->escape($username).'\', '.$intial_group_id.', \''.$password_hash.'\', \''.$email1.'\', '.$email_setting.', '.$save_pass.', '.$timezone.' , \''.$language.'\', \''.$pun_config['o_default_style'].'\', '.$now.', \''.get_remote_address().'\', '.$now.')') or error('Impossible de cr&eacute;er l\'utilisateur', __FILE__, __LINE__, $db->error());
	$new_uid = $db->insert_id();

	// Should we alert people on the admin mailing list that a new user has registered?
	if ($pun_config['o_regs_report'] == '1')
	{
		$mail_subject = 'Alerte - Nouvelle inscription';
		$mail_message = 'L\'utilisateur \''.$username.'\' est enregistr&eacute; sur les forums &agrave; '.$pun_config['o_base_url']."\n\n".'Profil de l\'utilisateur : '.$pun_config['o_base_url'].'/profile.php?id='.$new_uid."\n\n".'-- '."\n".'Forum Mailer'."\n".'(Ne pas r&eacute;pondre &agrave; ce message)';

		pun_mail($pun_config['o_mailing_list'], $mail_subject, $mail_message);
	}

	// Must the user verify the registration or do we log him/her in right now?
	if ($_POST['random_pass'] == '1')
	{
		// Load the "welcome" template
		$mail_tpl = trim(file_get_contents(PUN_ROOT.'lang/'.$pun_user['language'].'/mail_templates/welcome.tpl'));

		// The first row contains the subject
		$first_crlf = strpos($mail_tpl, "\n");
		$mail_subject = trim(substr($mail_tpl, 8, $first_crlf-8));
		$mail_message = trim(substr($mail_tpl, $first_crlf));
		$mail_subject = str_replace('<board_title>', $pun_config['o_board_title'], $mail_subject);
		$mail_message = str_replace('<base_url>', $pun_config['o_base_url'].'/', $mail_message);
		$mail_message = str_replace('<username>', $username, $mail_message);
		$mail_message = str_replace('<password>', $password1, $mail_message);
		$mail_message = str_replace('<login_url>', $pun_config['o_base_url'].'/login.php', $mail_message);
		$mail_message = str_replace('<board_mailer>', $pun_config['o_board_title'].' '.$lang_common['Mailer'], $mail_message);
		pun_mail($email1, $mail_subject, $mail_message);
	}

	message('Utilisateur cr&eacute;&eacute;');
}
else
{
	// Display the admin navigation menu
	generate_admin_menu($plugin);

?>
	<div class="block">
		<h2><span>Gestion des utilisateurs - v<?php echo PLUGIN_VERSION ?> - Fr</span></h2>
		<div class="box">
			<div class="inbox">
				<p>Ce plugin vous permet de d&eacute;lester des utilisateurs. Vous pouvez filtrer selon la date de derni&egrave;re
				connexion et selon le nombre de messages post&eacute;s.</p>
				<p><strong>Attention : Utilisez ce plugin avec pr&eacute;caution ! Les changements prennent effet imm&eacute;diatement
				et sont irr&eacute;versibles (Il est fortement recommand&eacute; de faire une sauvegarde de vos donn&eacute;es avant
				d'effectuer l'op&eacute;ration).</strong></p>
				<p>Le plugin vous permet aussi d'ajouter vous-m&ecirc;me des utilisateurs, cela peut &ecirc;tre utile pour le cas o&ugrave;
				vous auriez d&eacute;sactiv&eacute; les inscriptions.</p>
			</div>
		</div>
	</div>
	<div class="blockform">
		<h2 class="block2"><span>D&eacute;lestage d'utilisateurs</span></h2>
		<div class="box">
			<form id="example" method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
				<div class="inform">
					<fieldset>
						<legend>Param&egrave;tres</legend>
						<div class="infldset">
						<table class="aligntop" cellspacing="0">
						<!--Thanks to wiseage for this function -->
							<tr>
								<th scope="row">D&eacute;lester par</th>
								<td>
									<input type="radio" name="prune_by" value="1" checked="checked" />&nbsp;<strong>Date d'inscription</strong>&nbsp;&nbsp;&nbsp;<input type="radio" name="prune_by" value="0" />&nbsp;<strong>Derni&egrave;re connexion</strong>
									<span>D&eacute;termine si le nombre de jours minimum est calcul&eacute; depuis la derni&egrave;re connexion ou la date d'inscription.</span>
								</td>
							</tr>
						<!--/Thanks to wiseage for this function -->
							<tr>
								<th scope="row">Nombre de jours minimum</th>
								<td>
									<input type="text" name="days" value="28" size="25" tabindex="1" />
									<span>Les utilisateurs qui ne sont pas venus depuis ce nombre de jours seront supprim&eacute;s (selon le param&egrave;tre
									sp&eacute;cifi&eacute; ci-dessus).</span>
								</td>
							</tr>
							<tr>
								<th scope="row">Nombre maximum de messages</th>
								<td>
									<input type="text" name="posts" value="1"  size="25" tabindex="1" />
									<span>Les utilisateurs qui ont plus de messages que ce nombre ne seront pas supprim&eacute;s. (Mettez donc
									1 pour supprimer tous les utilisateurs qui n'ont jamais post&eacute;).</span>
								</td>
							</tr>
							<tr>
								<th scope="row">Inclure les administrateurs et les mod&eacute;rateurs ?</th>
								<td>
									<input type="radio" name="admods_delete" value="1" />&nbsp;<strong>Oui</strong>&nbsp;&nbsp;&nbsp;<input type="radio" name="admods_delete" value="0" checked="checked" />&nbsp;<strong>Non</strong>
									<span>Si oui, le d&eacute;lestage concernera aussi les mod&eacute;rateurs et administrateurs.</span>
								</td>
							</tr>
							<tr>
								<th scope="row">Etat des utilisateurs</th>
								<td>
									<input type="radio" name="verified" value="1" />&nbsp;<strong>Supprimer tous</strong>&nbsp;&nbsp;&nbsp;<input type="radio" name="verified" value="0" checked="checked" />&nbsp;<strong>Seulement ceux v&eacute;rifi&eacute;s</strong>&nbsp;&nbsp;&nbsp;<input type="radio" name="verified" value="2" />&nbsp;<strong>Seulement ceux non v&eacute;rifi&eacute;s</strong>
									<span>Un utilisateur "v&eacute;rifi&eacute;" est un utilisateur qui a valid&eacute; son inscription (dans le cas o&ugrave; la v&eacute;rification des insciptions est activ&eacute;e).</span>
								</td>
							</tr>
						</table>
						</div>
					</fieldset>
				</div>
			<p class="submitend"><input type="submit" name="prune" value="Lancer !" tabindex="2" /></p>
			</form>
		</div>

		<h2 class="block2"><span>Ajout d'utilisateur</span></h2>
		<div class="box">
			<form id="example" method="post" action="<?php echo $_SERVER['REQUEST_URI'] ?>">
				<div class="inform">
					<fieldset>
						<legend>Param&egrave;tres</legend>
						<div class="infldset">
						<table class="aligntop" cellspacing="0">
							<tr>
								<th scope="row">Nom d'utilisateur</th>
								<td>
									<input type="text" name="username" size="25" tabindex="3" />
								</td>
							</tr>
							<tr>
								<th scope="row">Courriel</th>
								<td>
									<input type="text" name="email" size="50" tabindex="3" />
								</td>
							</tr>
							<tr>
								<th scope="row">G&eacute;n&eacute;rer un mot de passe al&eacute;atoire ?</th>
								<td>
									<input type="radio" name="random_pass" value="1" />&nbsp;<strong>Oui</strong>&nbsp;&nbsp;&nbsp;<input type="radio" name="random_pass" value="0" checked="checked" />&nbsp;<strong>Non</strong>
									<span>Si Oui, un mot de passe al&eacute;atoire sera g&eacute;n&eacute;r&eacute; et envoy&eacute; &agrave; l'adresse ci-dessus.</span>
								</td>
							</tr>
							<tr>
								<th scope="row">Mot de passe</th>
								<td>
									<input type="text" name="password" size="25" tabindex="3" />
									<span>Si vous ne souhaitez pas de mot de passe al&eacute;atoire.</span>
								</td>
							</tr>
						</table>
						</div>
					</fieldset>
				</div>
				<p class="submitend"><input type="submit" name="add_user" value="Cr&eacute;er !" tabindex="4" /></p>
			</form>
		</div>
	</div>

<?php
}
?>